"use strict";
Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "aliasPlugin", {
  enumerable: true,
  get: () => aliasPlugin
});
const _path = /* @__PURE__ */ _interop_require_default(require("path"));
const _tsconfigpaths = require("@modern-js/utils/tsconfig-paths");
const _utils = require("@modern-js/utils");
function _interop_require_default(obj) {
  return obj && obj.__esModule ? obj : {
    default: obj
  };
}
const { resolvePath } = require("babel-plugin-module-resolver");
const defaultPaths = {
  "@": [
    "./src"
  ]
};
const aliasPlugin = (alias) => {
  const { absoluteBaseUrl, isTsPath, isTsProject = false } = alias;
  const mergedPaths = isTsPath ? alias.paths || {} : {
    ...defaultPaths,
    ...alias.paths || {}
  };
  let tsPaths = {};
  if (isTsProject) {
    tsPaths = (0, _utils.getUserAlias)(mergedPaths);
  }
  tsPaths = Object.keys(tsPaths).reduce((o, key) => {
    if (typeof tsPaths[key] === "string") {
      return {
        ...o,
        [`${key}`]: [
          tsPaths[key]
        ]
      };
    }
    return {
      ...o,
      [`${key}`]: tsPaths[key]
    };
  }, {});
  const resolvePathFn = (sourcePath, currentFile, opts) => {
    if (sourcePath === "." || sourcePath === "./") {
      return sourcePath;
    }
    const matchPath = (0, _tsconfigpaths.createMatchPath)(absoluteBaseUrl, tsPaths, [
      "index"
    ]);
    const result = matchPath(sourcePath, void 0, void 0, [
      ".js",
      ".jsx",
      ".ts",
      ".tsx"
    ]);
    if (result) {
      const relativePath = _path.default.relative(_path.default.dirname(currentFile), _path.default.dirname(result));
      const fileName = _path.default.basename(result);
      const filePath = _path.default.normalize(`${relativePath.length === 0 ? "." : relativePath}/${fileName}`).replace(/\\/, "/");
      return filePath.startsWith(".") ? filePath : `./${filePath}`;
    }
    return resolvePath(sourcePath, currentFile, opts);
  };
  const typescriptExts = [
    ".ts",
    ".tsx",
    ".js",
    ".jsx",
    ".es",
    ".es6",
    ".mjs"
  ];
  return [
    "babel-plugin-module-resolver",
    {
      root: absoluteBaseUrl,
      alias: mergedPaths,
      resolvePath: isTsPath ? resolvePathFn : void 0,
      extensions: isTsProject ? typescriptExts : void 0
    }
  ];
};
